/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import {z} from "zod";

export const ListPageSchema = z.object({
    path: z.string(),
    name: z.string(),
    sha: z.string(),
    downloadUrl: z.string().url(),
    id: z.number().positive(),
});

export type ListPage = z.infer<typeof ListPageSchema>;

export const PageListSchema = z.array(ListPageSchema);

export type PageList = z.infer<typeof PageListSchema>;

export const PageSchema = z.object({
    path: z.string(),
    name: z.string(),
    sha: z.string(),
    downloadUrl: z.string().url(),
    content: z.string(),
    size: z.number().gte(0),
    id: z.number().positive(),
});

export type Page = z.infer<typeof PageSchema>;

export type Pages = {
    dirs: { [key: string]: Pages },
    files: { [key: string]: ListPage }
}